#include once "crt.bi"
#include once "fbgfx.bi"
#define ENET_DLL
#include "enet/enet.bi"

#define PROT_SAY "SAY "
#define PROT_NEWPEER "NEW "
#define PROT_OLDPEER "OLD "
#define PROT_CHANGENAME "REN "
#define PROT_NEWNAME "NME "
#define PROT_LISTPEERS "WHO "
#define PROT_WHISPER "WSP "


#define SERVER_MAX_CHANNELS 10

enum enet_error
	eeFailedInit = -1
end enum

declare function init_enet() as enet_error
declare function join(byref hostAddress as string, byval port as integer, byval channels as integer, byref tPeer as ENetPeer ptr ) as ENetHost ptr
declare sub client_process(byval cliHost as ENetHost ptr)
declare function host(byref hostAddress as string, byval port as integer, byval connections as integer) as ENetHost ptr
declare sub host_process(byval srvHost as ENetHost ptr, byref tPeer as ENetPeer ptr )
declare sub cleanup(byval srvHost as ENetHost ptr)


dim as ENetHost ptr client
dim as ENetPeer ptr Peer

init_enet()

dim as string ip
input "Enter ip to connect to"; ip
if ip = "" then ip = "127.0.0.1" 'loop back to localhost...
client = join(ip, 42069, SERVER_MAX_CHANNELS, Peer)

while inkey$<>"": wend

if client = 0 then
    print "Exiting due to error."
    cleanup(client)
end if

dim as string k, buf
dim as ENetPacket ptr Packet
dim as integer oldline

do until multikey(1)
	k=inkey$
	if k=chr(13) or len(buf)>70 then
		oldline=csrlin
		locate 25, 1: print string(75," ");
		locate oldline, 1
		
		if left(buf,1)="/" then
            dim as integer i = instr(buf, " ")
            select case mid(buf, 2, i-2)
                case "name"
                    buf=PROT_CHANGENAME+mid(buf, i+1)
                case "who"          		            			
                    buf=PROT_LISTPEERS
            end select
        else
            buf=PROT_SAY + buf
        end if
        
        Packet = enet_packet_create ( strptr(buf), len(buf)+1 , ENET_PACKET_FLAG_RELIABLE)
        enet_peer_send (peer, 0, packet)
        enet_host_flush (Client)
        'enet_packet_destroy( Packet )
        buf=""
        
    elseif k=chr(8) then
		if len(buf)>0 then
			buf=left(buf,len(buf)-1)
			oldline=csrlin
			locate 25, 1: color 2: print "> "; buf; "_ ";
			locate oldline,1
        end if		
    elseif len(k)>0 then
		buf+=k
		
		oldline=csrlin
		locate 25, 1: color 2: print "> "; buf; "_";
		locate oldline,1
    end if
    
'    buf=PROT_SAY & "X"
'    Packet = enet_packet_create ( Cast(zstring ptr, strptr(buf)), len(buf) + 1 , ENET_PACKET_FLAG_RELIABLE)
'    enet_peer_send (peer, 0, packet)
'    'enet_host_flush (Client)
'    'enet_packet_destroy( Packet )
'    buf=""
    
    
    client_process(client)
    sleep 10,1
loop

enet_peer_disconnect(peer, 0)
enet_host_flush (Client)

cleanup(client)




function init_enet() as enet_error
    
	if enet_initialize() <> 0 then
        print "An error occurred while initializing ENet."
        return eeFailedInit
    end if
    
end function


function join(byref hostAddress as string, byval port as integer, byval channels as integer, byref tPeer as ENetPeer ptr ) as ENetHost ptr
	dim as ENetAddress address
    dim as ENetHost ptr tempClient
	dim as ENetPeer ptr peer  
    
    
    if hostAddress = "" then
    	address.host = ENET_HOST_ANY 	
    else
    	enet_address_set_host (@address, hostAddress)
    end if
    
    address.port = port
    
    tempClient = enet_host_create (NULL, 1, 0, 0)
    
	if (tempClient = NULL) then
		print  "An error occurred while trying to create an ENet client host."
		return NULL
    end if
    
	peer = enet_host_connect (tempClient, @address, channels)    
    tPeer = peer
	if (peer = NULL) then
		print "No available peers for initiating an ENet connection."
		return 0
    end if
    
  	join = tempClient
    
end function


sub client_process(byval cliHost as ENetHost ptr)
	dim as ENetEvent Event
	do while (enet_host_service (cliHost, @Event, 0) > 0)
		select case Event.ChannelID
			case 0
                
				select case event.type
                    case ENET_EVENT_TYPE_CONNECT
                        print "Now connected"
                        
                        Cast(zstring ptr, Event.peer->data) = allocate(len("Client information"))
                        
                        *Cast(zstring ptr, Event.peer->data) = "Client information"
                        
                    case ENET_EVENT_TYPE_RECEIVE
                        
                        dim as string msg=mid(*Cast(zstring ptr, Event.packet->data),5)
                        dim as integer i=instr(msg, " ")
                        dim as string 	part1=left(msg, i-1), part2=mid(msg,i+1)
                        select case left(*Cast(zstring ptr, Event.packet->data),4)
                            case PROT_SAY					
                                color 15:print part1;
                                color 7: print ": "; part2
                                
                            case PROT_WHISPER					
                                color 13:print part1; " whispers";
                                color 7: print ": "; part2
								
                            case PROT_NEWPEER
                                color 14	
                                print "* "; msg; " connected =)"
                                
                            case PROT_OLDPEER
                                color 14
                                print "* "; msg; " disconnected =("	
                                
                            case PROT_NEWNAME
                                color 14
                                print "* "; part1; " is now known as "; part2
                                
                            case else
                                print "* Unknown packet identifier: "; left(*Cast(zstring ptr, Event.packet->data),4)
                        end select
                        
                        'enet_packet_destroy (event.packet)
                        
                    case ENET_EVENT_TYPE_DISCONNECT
                        print *Cast(zstring ptr,event.peer->data) & "disconected."
                        
                        Event.peer->data = NULL
                end select
            case 1
                '				Select Case event.type
                '					Case ENET_EVENT_TYPE_RECEIVE
                '						Dim As Single Matrix(15)
                '						MemCpy( @Matrix(0), Event.Packet->Data, 16 * SizeOf( Single) )
                '						
                '						For q As Integer = 0 To 15
                '							Print Matrix(q)
                '						Next
                '						
                '				End Select
        end select    
    loop
end sub


sub cleanup(byval cliHost as ENetHost ptr)
	enet_host_destroy(cliHost)
	enet_deinitialize()
end sub
