#Include Once "crt.bi"
#Include "global.bi"

'Type Vector3D'
'As Single X,Y,Z
'End Type

dim as server svr

print "Server starting..."

if enet_initialize() <> 0 then
    print "An error occurred while initializing ENet."
    end
end if

svr.socket = createServer(SERVER_HOSTNAME, SERVER_PORT, MAX_CLIENTS)

if svr.socket = 0 then
    print "Exiting due to error."
    cleanup(svr.socket)
    end
end if

print "Server Running."

dim as integer i, j, c, nextClId=0
dim as double nextPingTime=timer+PING_INTERVAL
dim as ENetEvent evt

svr.status=SVRSTAT_RUNNING
do
    
    if enet_host_service ( svr.socket, @evt, 0 ) > 0 then
        select case evt.type
            case ENET_EVENT_TYPE_CONNECT
                
                i=nextClId
                nextClId+=1
                
                if i=MAX_CLIENTS then
                    for i=0 to MAX_CLIENTS
                        if svr.cl(i).flags=CFLAG_EMPTY then exit for
                    next i
                end if
                
                print "Cli" & i & " connected from " & _
                evt.peer->address.host & ":" & _
                evt.peer->address.port
                
                Cast(integer, evt.peer->data) = i
                
                ' Set vitals
                svr.cl(i).uid=i
                svr.cl(i).socket=evt.peer
                svr.cl(i).flags=CFLAG_LIVE
                
                ' Set properties
                svr.cl(i).name="Anonymous"+str(i)
                
                ' Send welcome message
                dim as string msg = PROT_WHISPER + "Lobby Welcome to the lobby!"
                sendToCli(@svr, i, msg)
                
                
                ' Broadcast
                msg = PROT_NEWPEER + svr.cl(i).name
                'sendToAll(@svr, 0, strptr(msg), len(msg) + len(PROT_SAY) )
                sendToAll(@svr, 0, msg)
                
                
            case ENET_EVENT_TYPE_RECEIVE          
                i = Cast(integer, evt.peer->data)
                
                if svr.cl(i).flags=CFLAG_LIVE then                
                    select case left(*Cast(zstring ptr, evt.packet->data),4)
                        case PROT_SAY
                            dim as string msg = PROT_SAY+svr.cl(i).name+" "+mid(*Cast(zstring ptr, evt.packet->data),5) 			
                            'sendToAll(@svr, 0, strptr(msg), len(msg) )
                            sendToAll(@svr, 0, msg )

                        case PROT_CHANGENAME
                            dim as string oldname=svr.cl(i).name
                            svr.cl(i).name=mid(*Cast(zstring ptr, evt.packet->data),5)
                            
                            if instr(svr.cl(i).name, " ") then svr.cl(i).name = "Lamer" & int(timer)
                            
                            dim as string msg = PROT_NEWNAME + oldname + " " + svr.cl(i).name 			
                            sendToAll(@svr, 0, msg )
                            
                        case PROT_LISTPEERS
                            dim as string listing
                            listing="Chatters:"+chr(13)+chr(10)
                            for j=0 to MAX_CLIENTS
                                if svr.cl(j).flags=CFLAG_LIVE then
                                    listing+= svr.cl(j).name & " (#" & j & ", " & _
                                    svr.cl(j).socket->roundTripTime & " +/- " & svr.cl(j).socket->roundTripTimeVariance & ", " & _
                                    svr.cl(j).socket->packetLoss & ", " & svr.cl(j).socket->packetsLost & ", "& _
                                    svr.cl(j).socket->packetsSent & ")" & _
                                    chr(13) & chr(10)
                                    
                                end if
                            next j
                            dim as string msg = PROT_WHISPER + "Lobby " + listing 	
                            sendToCli(@svr, i, msg )
                            
                        case else
                            print "Unknown packet identifier: " + left(*Cast(zstring ptr, evt.packet->data),4)
                    end select
                else
                    print "Packet from unconnected or dead client. Destroying."
                end if
                
                'enet_packet_destroy (evt.packet)
                
            case ENET_EVENT_TYPE_DISCONNECT
                i = Cast(integer, evt.peer->data)
                
                print "Cli" & str(i) & " disconnected."
                
                'broadcast
                dim as string msg = PROT_OLDPEER + svr.cl(i).name
                sendToAll(@svr, 0, msg )
                
                'clean up
                
                i=Cast(integer, evt.peer->data)
                
                svr.cl(i).flags=CFLAG_EMPTY
                svr.cl(i).uid=-1
                svr.cl(i).name=""
                enet_peer_reset(svr.cl(i).socket)
                
                evt.peer->data=0
                
        end select
    end if
    
    
 	if timer>nextPingTime then
        for j=0 to MAX_CLIENTS
			if svr.cl(i).flags=CFLAG_LIVE then
				enet_peer_ping( svr.cl(i).socket )
            end if
        next j
		nextPingTime = timer + PING_INTERVAL
    end if
    sleep 1,1
loop until inkey = chr(27)
svr.status = SVRSTAT_QUITING

print "Cleaning up."

cleanup(svr.socket)

print "Hit any key."
sleep
end


'sub sendToAll( byref svr as server ptr, byref channel as uinteger, byref body as any ptr, byref bodylen as uinteger)
'	'Dim As enetPacket Ptr pck = enet_packet_create(Body, BodyLen * Sizeof(Body), ENET_PACKET_FLAG_RELIABLE)
'    bodylen = len(*Cast(zString Ptr, body))
'    dim as enetPacket ptr pck = enet_packet_create(body, bodylen, ENET_PACKET_FLAG_RELIABLE)
'	print string(75,"-")
'	print "DATA TO SEND:           "; *Cast(zstring ptr, body)
'	print "DATA ENET WANTS TO SEND:"; *Cast(zstring ptr, pck->data)
'    
'    'print 
'
'	enet_host_broadcast(svr->socket, channel, pck)
'	enet_host_flush(svr->socket)
'end sub
'
'sub sendToCli(byref svr as server ptr, byref clId as uinteger, byref body as any ptr, byref bodylen as uinteger)
'	'Dim As enetPacket Ptr pck=enet_packet_create(body, bodylen * Sizeof(Body), ENET_PACKET_FLAG_RELIABLE)
'    bodylen = len(*Cast(zString Ptr, body))
'    dim as enetPacket ptr pck=enet_packet_create(body, bodylen, ENET_PACKET_FLAG_RELIABLE)
'    
'	print string(75,"-")
'	print "DATA TO SEND:           "; *Cast(zstring ptr, body)
'	print "DATA ENET WANTS TO SEND:"; *Cast(zstring ptr, pck->data)
'    'print len(*Cast(zString Ptr, body))
'
'	enet_peer_send( svr->cl(clId).socket, 0, pck )
'	enet_host_flush(svr->socket)
'    
'end sub

sub sendToAll( byref svr as server ptr, byref channel as uinteger, byref body as string )
	'Dim As enetPacket Ptr pck = enet_packet_create(Body, BodyLen * Sizeof(Body), ENET_PACKET_FLAG_RELIABLE)
    dim as uinteger bodylen = len(body) + 1
    dim as enetPacket ptr pck = enet_packet_create( strptr(body), bodylen, ENET_PACKET_FLAG_RELIABLE)
	print string(75,"-")
	print "DATA TO SEND:           "; body
	print "DATA ENET WANTS TO SEND:"; *Cast(zstring ptr, pck->data)
    
    'print 

	enet_host_broadcast(svr->socket, channel, pck)
	enet_host_flush(svr->socket)
end sub

sub sendToCli(byref svr as server ptr, byref clId as uinteger, byref body as string )
	'Dim As enetPacket Ptr pck=enet_packet_create(body, bodylen * Sizeof(Body), ENET_PACKET_FLAG_RELIABLE)
    dim as uinteger bodylen = len(body) + 1
    dim as enetPacket ptr pck=enet_packet_create( strptr(body), bodylen, ENET_PACKET_FLAG_RELIABLE)
    
	print string(75,"-")
	print "DATA TO SEND:           "; body
	print "DATA ENET WANTS TO SEND:"; *Cast(zstring ptr, pck->data)
    'print len(*Cast(zString Ptr, body))

	enet_peer_send( svr->cl(clId).socket, 0, pck )
	enet_host_flush(svr->socket)
    
end sub



function createServer(byref hostAddress as string, byval port as integer, byval connections as integer) as ENetHost ptr
    dim as ENetAddress address
    dim as ENetHost ptr tempServer
    
    if hostAddress = "" then
	    address.host = ENET_HOST_ANY 	
    else
    	enet_address_set_host (@address, hostAddress)
    end if
    
    address.port = port
    
    tempServer = enet_host_create (@address, connections, 0, 0)
    
    
	if (tempServer = NULL) then
		print  "An error occurred while trying to create an ENet server host."
    end if
    
  	return tempServer
    
end function

sub cleanup(byval srvHost as ENetHost ptr)
	enet_host_destroy(srvHost)
	enet_deinitialize()
end sub
